import {
    ApiModel
} from "../../utils/api";
const _Http = new ApiModel();
import {
    TestVerify
} from "../../utils/verify";
const _Verify = new TestVerify();
Page({

    /**
     * 页面的初始数据
     */
    data: {
        isDisabled: false, //是否禁用
        butText: "保存", //按钮文字
        popups: false, //弹出层控制
        /*  */
        fbrand: "", //品牌名称
        attinfos: [], // 图片列表
        isLogo: [], //用于判断是否上传logo
        saleprodclass: [], //经营类目
        showSaleprodclass: "", //显示经营类目
        fcontact: "", //联系人
        fphonenumber: "", //联系方式
        fagentname: "", //商户名称
        fintroduction: "", //商户介绍
        faddress: "", //地址
        fdutyparagraph: "", //统一社会代码
        requestType: "普通修改", //请求类型
        /*  */
        errTips: {
            fbrand: false,
            attinfos: false,
            saleprodclass: false,
            fcontact: false,
            fphonenumber: false,
            fagentname: false,
            fintroduction: false,
            faddress: false,
        }
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        // 判断主子账号 是否禁用
        this.setData({
            isDisabled: (wx.getStorageSync('userData').fisadministrator == 1) ? false : true
        });
        //判断进入方式
        if (options.data == null) {
            console.log("注册进入")
            this.setData({
                requestType: "商户认证"
            })
        } else if (options.data == 1) {
            wx.showToast({
                title: '商户信息审核中',
                icon: 'none',
                duration: 5000
            });
            this.setData({
                requestType: "商户认证",
                isDisabled: true
            })
        } else {
            console.log("商户进入");
            const data = JSON.parse(options.data);
            console.log(data)
            this.returnData(data)
        }
    },
    /* 添加图片 */
    imageChange(data) {
        this.setData({
            attinfos: data.detail.fileList
        })
    },
    /* 选择类目回调 */
    saleprodChange(arr) {
        let detail = arr.detail,
            showSaleprodclass = "";
        for (let i = 0; i < detail.length; i++) {
            showSaleprodclass += (detail[i] + '，');
        };
        this.setData({
            popups: false,
            saleprodclass: detail,
            showSaleprodclass: showSaleprodclass.slice(0, showSaleprodclass.length - 1)
        })
    },
    /* 返回数据 */
    returnData(data) {
        let attinfos = [];
        // 格式化图片
        if (data.attinfos.length >= 1) {
            const i = data.attinfos.length - 1;
            attinfos = [{
                url: data.attinfos[i].fobsurl,
                ownerid: data.attinfos[i].ownerid,
                tattachmentid: data.attinfos[i].tattachmentid,
                ownertable: data.attinfos[i].ownertable,
                fdocument: data.attinfos[i].fdocument
            }]
        }

        //格式化经营类目
        if (data.saleprodclass.length >= 1) {
            this.saleprodChange({
                detail: data.saleprodclass
            })
        }

        this.setData({
            fbrand: data.fbrand,
            saleprodclass: data.saleprodclass,
            fcontact: data.fcontact,
            fphonenumber: data.fphonenumber,
            fintroduction: data.fintroduction,
            fagentname: data.fagentname,
            faddress: data.faddress,
            fdutyparagraph: data.fdutyparagraph,
            attinfos,
        })
    },
    /* 提交数据 */
    submit() {
        if (!this.formVerify()) return wx.showToast({
            title: '请检查表单内容',
            icon: "error"
        });
        if (this.data.attinfos.length < 1) return wx.showToast({
            title: '请上传品牌LOGO!',
            icon: "none"
        });
        /* 发送请求 */
        _Http.basic({
            "accesstoken": wx.getStorageSync('userData').token,
            "classname": "customer.tagents.tagents",
            "method": "modify_enterpriseAgent",
            "content": {
                "ftype": this.data.requestType,
                "data": [{
                    "fbrand": this.data.fbrand,
                    "saleprodclass": this.data.saleprodclass,
                    "fcontact": this.data.fcontact,
                    "fphonenumber": this.data.fphonenumber,
                    "fagentname": this.data.fagentname,
                    "fintroduction": this.data.fintroduction,
                    "faddress": this.data.faddress,
                    "fdutyparagraph": this.data.fdutyparagraph,
                }]
            }
        }).then(res => {
            if (res.msg != '成功') return wx.showToast({
                title: res.data,
            })
            wx.showToast({
                title: '提交成功',
            });
            setTimeout(() => {
                wx.navigateBack({
                    delta: 1,
                })
            }, 500)
        })
    },
    /* 表单验证 */
    formVerify() {
        let errTips = this.data.errTips,
            verify = true;
        /* 验证品牌名 */
        if (!_Verify.required(this.data.fbrand)) {
            errTips.fbrand = true;
            verify = false;
        }
        /* 验证经营类目  */
        if (!_Verify.required(this.data.showSaleprodclass)) {
            errTips.saleprodclass = true;
            verify = false;
        }
        /* 验证联系人  */
        if (!_Verify.required(this.data.fcontact)) {
            errTips.fcontact = true;
            verify = false;
        }
        /* 验证联系方式  */
        if (!_Verify.phoneNumber(this.data.fphonenumber)) {
            errTips.fphonenumber = true;
            verify = false;
        }
        /* 验证商户名称  */
        if (!_Verify.required(this.data.fagentname)) {
            errTips.fagentname = true;
            verify = false;
        }
        /* 验证商户介绍  */
        if (!_Verify.required(this.data.fintroduction)) {
            errTips.fintroduction = true;
            verify = false;
        }
        /* 验证地址  */
        if (!_Verify.required(this.data.faddress)) {
            errTips.faddress = true;
            verify = false;
        }
        this.setData({
            errTips
        })
        return verify;
    },
    /* 弹出层 */
    showPop() {
        if (this.data.isDisabled) return;
        this.setData({
            popups: !this.data.popups
        })
    },
    /* 获取焦点 */
    inputFocus(e) {
        const {
            name
        } = e.currentTarget.dataset;
        let errTips = this.data.errTips;
        errTips[name] = false;
        this.setData({
            errTips
        })
    },
    /* 失去焦点 */
    inputBlur(e) {
        const {
            name
        } = e.currentTarget.dataset;
        const {
            value
        } = e.detail;
        let errTips = this.data.errTips;
        /* 联系方式验证 */
        if (name == 'fphonenumber') {
            if(!_Verify.phoneNumber(this.data.fphonenumber, true)) errTips[name] = true;
        }
        if (value.trim() == "") {
            errTips[name] = true;
        }
        this.setData({
            errTips
        })
    },
    /* 更改logo */
    logoChange(data) {
        this.setData({
            isLogo: data.detail.fileList
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})